# X-Economy

This is a plugin for [X-Plane](http://x-plane.com), to connect and use [FSEconomy](http://www.fseconomy.net/).
The plugin uses Sandy Barbour's [Python interface](http://www.xpluginsdk.org/python_interface.htm), so plugin may work on Mac, Linux and Windows too.

# Download

[Download Latest release](http://server.fseconomy.net/static/x-client/x-economy-current.zip)

# Content of the ZIP archive

* `PI_xfse.py` is the actual client script. It's the only file that is mandatorily needed to use X-Economy.
* `optional_fueltanks` is an *optional* script allowing users to customize the fuel tank mapping
* `optional_interface_lua` is an *optional* FlyWithLua script providing an in-cockpit HUD to control the client
* `optional_interface_python` is an *optional* Python script providing an in-cockpit HUD to control the client
* `API.md` documents the X-Plane data refs and commands exposed by the client to third-party plugins

**Please Note:** all folders marked *optional_* are **not needed** to operate the client, they're just helpers to
improve user experience. Concerning the optional *interface* scripts, it is most adviseable to chose only one.
Apart from those shipped with the client, there are also third-party interface scripts available, e. g.
[FSE HUD](https://forums.x-plane.org/index.php?/files/file/53617-fse-hud/) by TogFox.

# How to install

Please follow the instructions given in the FSE Operations Guide:

[How to install](https://sites.google.com/site/fseoperationsguide/getting-started/using-the-fse-client/x-plane#TOC-Installation)

**Please Note:** should you experience difficulties installing the Python interface, there's a shortcut for Windows users - just
try the [Windows Installer](https://forums.x-plane.org/index.php?/files/file/15881-ground-services-noaa-weather-windows-net-installer/)
provided by Joan (but don't forget to deactivate Python scripts you don't want to use, e. g. NOAA Weather etc.)

# Updating X-Economy

The Python Interface compiles every script into byte code. This byte code is stored in a separate file, using the same name as the script file, but with the extension `.pyc`. When updating the X-Economy script to a new version, please make sure to delete both, the `PI_xfse.py` **and** `PI_xfse.pyc` file from your `PythonScripts` folder before deploying the new script.

# Modifying your plane so that fse recognizes it

[Modifying your plane](https://sites.google.com/site/fseoperationsguide/getting-started/using-the-fse-client/x-plane#TOC-Modify-your-airplanes)

# Time Compression and Ground Speed Acceleration

The current version of X-Economy supports the use of time compression (Ctrl+t) and/or ground speed acceleration (Alt+t) to the pilot's convenience on longer flights. However, it limits the total maximum compression to 16x. The total compression is the resulting product from both, time compression and ground speed acceleration. Example: a time compression factor of 2x combined with a ground speed acceleration of 4x will result in an overall compression factor of 8x.

**Please Note:** When time compression or ground speed acceleration are used, the client will account the upscaled flight and lease time (i. e. one hour real time at 4x will result in the client to account 4 hours of flight time, and 4 hours of aircraft rental time).

# Thanks

Thanks to Andrew, Nikos, Venom and all the X-Plane guys for their help and input :)

# License
The MIT License